#!/bin/csh -f
# Script to run the program unresCSA on linux with MPICH/PBS (parallel version).
#
# This example script pertains to the 3P force field (see section 4 of the description).
# To use other force fields change the setenv instructions as in the respective 
# interactive scripts in the up-directory.

# The GB potentials is used with the 3P force field; DO NOT change the line below.
setenv POT GB

# The line below defines the system-specific input file; the example is for 1IGD.
setenv PREFIX IGD_3P7_iter81_1_i1

# Define the location of UNRES parameter file and binaries directory.
set DD = /users/adam/UNRES/PARAM
set BIN = /users/czarek/UNRES/NEW/bin
#---------------------------------
setenv THETPAR $DD/thetaml.5parm
setenv ROTPAR $DD/scgauss.parm
setenv TORPAR $DD/torsion_631Gdp.parm
setenv TORDPAR $DD/torsion_double_631Gdp.parm
setenv ELEPAR $DD/electr_631Gdp.parm
setenv SIDEPAR $DD/sc_GB_opt.3P7_iter81_1r
setenv FOURIER $DD/fourier_opt.parm.1igd_hc_iter3_3
setenv SCPPAR $DD/scp.parm

# Pattern database
setenv PATTERN $DD/patterns.cart
#--------------------------------------------

endif

set DEBUG = 0

$BIN/unres_pgf90.exe $*

if ("$3" != "-p4amslave") then
# Remove links
/bin/rm fort.*
# Clear empty files
find . -size 0 -exec rm {} \;
endif

